Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# osgProducer::OsgCameraGroup Class Reference

Inheritance diagram for osgProducer::OsgCameraGroup:

[legend]
List of all members.

## Public Types
typedef Producer::CameraGroup::ThreadingModel | ThreadingModel
typedef std::vector< osg::ref_ptr< GraphicsContextImplementation > > | GraphicsContextList
typedef std::vector< osg::ref_ptr< osgProducer::OsgSceneHandler > > | SceneHandlerList
## Public Member Functions
| OsgCameraGroup ()
| OsgCameraGroup (Producer::CameraConfig *cfg)
| OsgCameraGroup (const std::string &configFile)
| OsgCameraGroup (osg::ArgumentParser &arguments)
virtual | ~OsgCameraGroup ()
void | setApplicationUsage (osg::ApplicationUsage *au)
osg::ApplicationUsage * | getApplicationUsage ()
const osg::ApplicationUsage * | getApplicationUsage () const
void | setGraphicsContextList (GraphicsContextList &gcList)
GraphicsContextList & | getGraphicsContextList ()
const GraphicsContextList & | getGraphicsContextList () const
SceneHandlerList & | getSceneHandlerList ()
const SceneHandlerList & | getSceneHandlerList () const
void | setSceneData (osg::Node *scene)
| Set the scene data to be rendered.
osg::Node * | getSceneData ()
| Get the scene data being used for rendering.
const osg::Node * | getSceneData () const
void | setSceneDecorator (osg::Group *decorator)
osg::Group * | getSceneDecorator ()
const osg::Group * | getSceneDecorator () const
osg::Node * | getTopMostSceneData ()
const osg::Node * | getTopMostSceneData () const
virtual void | updatedSceneData ()
| Update internal structures w.r.t updated scene data.
void | setDisplaySettings (osg::DisplaySettings *ds)
osg::DisplaySettings * | getDisplaySettings ()
const osg::DisplaySettings * | getDisplaySettings () const
void | setCullSettings (const osg::CullSettings &cs)
osg::CullSettings & | getCullSettings ()
const osg::CullSettings & | getCullSettings () const
void | setFrameStamp (osg::FrameStamp *fs)
osg::FrameStamp * | getFrameStamp ()
const osg::FrameStamp * | getFrameStamp () const
void | setGlobalStateSet (osg::StateSet *sset)
osg::StateSet * | getGlobalStateSet ()
const osg::StateSet * | getGlobalStateSet () const
void | setClearColor (const osg::Vec4 &clearColor)
const osg::Vec4 & | getClearColor () const
void | setLODScale (float scale)
float | getLODScale () const
void | setFusionDistance (osgUtil::SceneView::FusionDistanceMode mode, float value=1.0f)
void | setRealizeSceneViewOptions (unsigned int options)
| Set the options to set up SceneView with, see osgUtil::SceneView::Options for available options.
unsigned int | getRealizeSceneViewOptions ()
void | setRealizeCallback (RealizeCallback *cb)
| Set the realize callback to use when once the render surfaces are realized.
RealizeCallback * | getRealizeCallback ()
| Get the realize callback.
const RealizeCallback * | getRealizeCallback () const
| Get the const realize callback.
void | advance ()
virtual bool | realize (ThreadingModel thread_model)
| Set the threading model and then call realize().
virtual bool | realize ()
| Realize the render surfaces (OpenGL graphics) and various threads, and call any realize callbacks.
virtual void | setView (const osg::Matrixd &matrix)
| Set the model view matrix of the camera group, by individually set all the camera groups's camera.
osg::Matrixd | getViewMatrix () const
| Get the model view martrix of the camera group, taking its value for camera 0.
virtual void | sync ()
virtual void | frame ()
| Dispatch the cull and draw for each of the Camera's for this frame.
virtual void | cleanup_frame ()
| Dispatch a clean up frame that should be called before closing a OsgCameraGroup, i.e.
## Protected Member Functions
virtual void | setUpSceneViewsWithData ()
void | _init ()
## Protected Attributes
osg::ApplicationUsage * | _applicationUsage
osg::ref_ptr< osg::Node > | _scene_data
osg::ref_ptr< osg::Group > | _scene_decorator
osg::ref_ptr< osg::StateSet > | _global_stateset
osg::Vec4 | _clear_color
osgUtil::SceneView::FusionDistanceMode | _fusionDistanceMode
float | _fusionDistanceValue
unsigned int | _realizeSceneViewOptions
GraphicsContextList | _gcList
SceneHandlerList | _shvec
osg::ref_ptr< RealizeCallback > | _realizeCallback
osg::ref_ptr< osg::DisplaySettings > | _ds
bool | _initialized
osg::CullSettings | _cullSettings
unsigned int | _frameNumber
osg::Timer | _timer
osg::Timer_t | _start_tick
osg::ref_ptr< osg::FrameStamp > | _frameStamp

## Member Typedef Documentation

typedef std::vector< osg::ref_ptr<GraphicsContextImplementation> > osgProducer::OsgCameraGroup::GraphicsContextList

typedef std::vector< osg::ref_ptr<osgProducer::OsgSceneHandler> > osgProducer::OsgCameraGroup::SceneHandlerList

typedef Producer::CameraGroup::ThreadingModel osgProducer::OsgCameraGroup::ThreadingModel

## Constructor & Destructor Documentation

osgProducer::OsgCameraGroup::OsgCameraGroup | ( |  | ) |

osgProducer::OsgCameraGroup::OsgCameraGroup | ( | Producer::CameraConfig * | cfg | ) |

osgProducer::OsgCameraGroup::OsgCameraGroup | ( | const std::string & | configFile | ) |

osgProducer::OsgCameraGroup::OsgCameraGroup | ( | osg::ArgumentParser & | arguments | ) |

virtual osgProducer::OsgCameraGroup::~OsgCameraGroup | ( |  | ) | `[virtual]`

## Member Function Documentation

void osgProducer::OsgCameraGroup::_init | ( |  | ) | `[protected]`

void osgProducer::OsgCameraGroup::advance | ( |  | ) |

virtual void osgProducer::OsgCameraGroup::cleanup_frame | ( |  | ) | `[virtual]`

| Dispatch a clean up frame that should be called before closing a OsgCameraGroup, i.e. on exit from an app. The clean up frame first release all GL objects associated with all the graphics context associated with the camera group, then runs a special frame that does the actual OpenGL deletion of GL objects for each graphics context.

virtual void osgProducer::OsgCameraGroup::frame | ( |  | ) | `[virtual]`

| Dispatch the cull and draw for each of the Camera's for this frame. Reimplemented in osgProducer::Viewer.

const osg::ApplicationUsage* osgProducer::OsgCameraGroup::getApplicationUsage | ( |  | ) | const`[inline]`

osg::ApplicationUsage* osgProducer::OsgCameraGroup::getApplicationUsage | ( |  | ) | `[inline]`

const osg::Vec4& osgProducer::OsgCameraGroup::getClearColor | ( |  | ) | const

const osg::CullSettings& osgProducer::OsgCameraGroup::getCullSettings | ( |  | ) | const`[inline]`

osg::CullSettings& osgProducer::OsgCameraGroup::getCullSettings | ( |  | ) | `[inline]`

const osg::DisplaySettings* osgProducer::OsgCameraGroup::getDisplaySettings | ( |  | ) | const`[inline]`

osg::DisplaySettings* osgProducer::OsgCameraGroup::getDisplaySettings | ( |  | ) | `[inline]`

const osg::FrameStamp* osgProducer::OsgCameraGroup::getFrameStamp | ( |  | ) | const`[inline]`

osg::FrameStamp* osgProducer::OsgCameraGroup::getFrameStamp | ( |  | ) | `[inline]`

const osg::StateSet* osgProducer::OsgCameraGroup::getGlobalStateSet | ( |  | ) | const`[inline]`

osg::StateSet* osgProducer::OsgCameraGroup::getGlobalStateSet | ( |  | ) | `[inline]`

const GraphicsContextList& osgProducer::OsgCameraGroup::getGraphicsContextList | ( |  | ) | const`[inline]`

GraphicsContextList& osgProducer::OsgCameraGroup::getGraphicsContextList | ( |  | ) | `[inline]`

float osgProducer::OsgCameraGroup::getLODScale | ( |  | ) | const

const RealizeCallback* osgProducer::OsgCameraGroup::getRealizeCallback | ( |  | ) | const`[inline]`

| Get the const realize callback.

RealizeCallback* osgProducer::OsgCameraGroup::getRealizeCallback | ( |  | ) | `[inline]`

| Get the realize callback.

unsigned int osgProducer::OsgCameraGroup::getRealizeSceneViewOptions | ( |  | ) | `[inline]`

const osg::Node* osgProducer::OsgCameraGroup::getSceneData | ( |  | ) | const`[inline]`

osg::Node* osgProducer::OsgCameraGroup::getSceneData | ( |  | ) | `[inline]`

| Get the scene data being used for rendering. Returns: The node being used as the starting point during the rendering traversal of the scene graph.

const osg::Group* osgProducer::OsgCameraGroup::getSceneDecorator | ( |  | ) | const`[inline]`

osg::Group* osgProducer::OsgCameraGroup::getSceneDecorator | ( |  | ) | `[inline]`

const SceneHandlerList& osgProducer::OsgCameraGroup::getSceneHandlerList | ( |  | ) | const`[inline]`

SceneHandlerList& osgProducer::OsgCameraGroup::getSceneHandlerList | ( |  | ) | `[inline]`

const osg::Node* osgProducer::OsgCameraGroup::getTopMostSceneData | ( |  | ) | const

osg::Node* osgProducer::OsgCameraGroup::getTopMostSceneData | ( |  | ) |

osg::Matrixd osgProducer::OsgCameraGroup::getViewMatrix | ( |  | ) | const

| Get the model view martrix of the camera group, taking its value for camera 0.

virtual bool osgProducer::OsgCameraGroup::realize | ( |  | ) | `[virtual]`

| Realize the render surfaces (OpenGL graphics) and various threads, and call any realize callbacks. Reimplemented in osgProducer::Viewer.

virtual bool osgProducer::OsgCameraGroup::realize | ( | ThreadingModel | thread_model | ) | `[virtual]`

| Set the threading model and then call realize(). Reimplemented in osgProducer::Viewer.

void osgProducer::OsgCameraGroup::setApplicationUsage | ( | osg::ApplicationUsage * | au | ) | `[inline]`

void osgProducer::OsgCameraGroup::setClearColor | ( | const osg::Vec4 & | clearColor | ) |

void osgProducer::OsgCameraGroup::setCullSettings | ( | const osg::CullSettings & | cs | ) | `[inline]`

void osgProducer::OsgCameraGroup::setDisplaySettings | ( | osg::DisplaySettings * | ds | ) | `[inline]`

void osgProducer::OsgCameraGroup::setFrameStamp | ( | osg::FrameStamp * | fs | ) |

void osgProducer::OsgCameraGroup::setFusionDistance | ( | osgUtil::SceneView::FusionDistanceMode | mode,
|  | float | value = 1.0f
| ) |

void osgProducer::OsgCameraGroup::setGlobalStateSet | ( | osg::StateSet * | sset | ) |

void osgProducer::OsgCameraGroup::setGraphicsContextList | ( | GraphicsContextList & | gcList | ) | `[inline]`

void osgProducer::OsgCameraGroup::setLODScale | ( | float | scale | ) |

void osgProducer::OsgCameraGroup::setRealizeCallback | ( | RealizeCallback * | cb | ) | `[inline]`

| Set the realize callback to use when once the render surfaces are realized.

void osgProducer::OsgCameraGroup::setRealizeSceneViewOptions | ( | unsigned int | options | ) | `[inline]`

| Set the options to set up SceneView with, see osgUtil::SceneView::Options for available options.

void osgProducer::OsgCameraGroup::setSceneData | ( | osg::Node * | scene | ) |

  | Set the scene data to be rendered. The scene graph traversal during rendering will start at the node passed as parameter. Parameters:
  scene | The node to be used as the starting point during the rendering traversal of the scene graph.

void osgProducer::OsgCameraGroup::setSceneDecorator | ( | osg::Group * | decorator | ) |

virtual void osgProducer::OsgCameraGroup::setUpSceneViewsWithData | ( |  | ) | `[protected, virtual]`

virtual void osgProducer::OsgCameraGroup::setView | ( | const osg::Matrixd & | matrix | ) | `[virtual]`

| Set the model view matrix of the camera group, by individually set all the camera groups's camera.

virtual void osgProducer::OsgCameraGroup::sync | ( |  | ) | `[virtual]`

virtual void osgProducer::OsgCameraGroup::updatedSceneData | ( |  | ) | `[virtual]`

| Update internal structures w.r.t updated scene data. Reimplemented in osgProducer::Viewer.

## Member Data Documentation

osg::ApplicationUsage* osgProducer::OsgCameraGroup::_applicationUsage`[protected]`

osg::Vec4 osgProducer::OsgCameraGroup::_clear_color`[protected]`

osg::CullSettings osgProducer::OsgCameraGroup::_cullSettings`[protected]`

osg::ref_ptr<osg::DisplaySettings> osgProducer::OsgCameraGroup::_ds`[protected]`

unsigned int osgProducer::OsgCameraGroup::_frameNumber`[protected]`

osg::ref_ptr<osg::FrameStamp> osgProducer::OsgCameraGroup::_frameStamp`[protected]`

osgUtil::SceneView::FusionDistanceMode osgProducer::OsgCameraGroup::_fusionDistanceMode`[protected]`

float osgProducer::OsgCameraGroup::_fusionDistanceValue`[protected]`

GraphicsContextList osgProducer::OsgCameraGroup::_gcList`[protected]`

osg::ref_ptr<osg::StateSet> osgProducer::OsgCameraGroup::_global_stateset`[protected]`

bool osgProducer::OsgCameraGroup::_initialized`[protected]`

osg::ref_ptr<RealizeCallback> osgProducer::OsgCameraGroup::_realizeCallback`[protected]`

unsigned int osgProducer::OsgCameraGroup::_realizeSceneViewOptions`[protected]`

osg::ref_ptr<osg::Node> osgProducer::OsgCameraGroup::_scene_data`[protected]`

osg::ref_ptr<osg::Group> osgProducer::OsgCameraGroup::_scene_decorator`[protected]`

SceneHandlerList osgProducer::OsgCameraGroup::_shvec`[protected]`

osg::Timer_t osgProducer::OsgCameraGroup::_start_tick`[protected]`

osg::Timer osgProducer::OsgCameraGroup::_timer`[protected]`

The documentation for this class was generated from the following file:

- OsgCameraGroup